<?php
/**
 * SimpleXMLExtended Class
 *
 * Extends the default PHP SimpleXMLElement class by 
 * allowing the addition of cdata
 *
 * @since 1.0
 *
 * @param string $cdata_text
 */
class SimpleXMLExtended extends SimpleXMLElement{   
  public function addCData($cdata_text){   
   $node= dom_import_simplexml($this);   
   $no = $node->ownerDocument;   
   $node->appendChild($no->createCDATASection($cdata_text));   
  } 
} 

/**
 * Get XML Data
 *
 * Turns the XML file into an object 
 *
 * @since 1.0
 *
 * @param string $file
 * @return object
 */
function getXML($file) {
	$xml = file_get_contents($file);
	$data = simplexml_load_string($xml, 'SimpleXMLExtended', LIBXML_NOCDATA);
	return $data;
}

/**
 * XML Save
 *
 * @since 2.0
 * @todo create and chmod file before ->asXML call (if it doesnt exist already, if so, then just chmod it.)
 *
 * @param object $xml
 * @param string $file Filename that it will be saved as
 * @return bool
 */
function XMLsave($xml, $file) {
	$success = $xml->asXML($file) === TRUE;
}

/**
 * Clean URL
 *
 * @since 1.0
 *
 * @param string $text
 * @return string
 */
function clean_url($text)  { 
	$text = strip_tags(strtolower($text)); 
	$code_entities_match = array(' ?',' ','--','&quot;','!','@','#','$','%','^','&','*','(',')','+','{','}','|',':','"','<','>','?','[',']','\\',';',"'",',','/','*','+','~','`','=','.'); 
	$code_entities_replace = array('','-','-','','','','','','','','','','','','','','','','','','','','','','','',''); 
	$text = str_replace($code_entities_match, $code_entities_replace, $text); 
	$text = urlencode($text);
	$text = str_replace('--','-',$text);
	$text = rtrim($text, "-");
	return $text; 
} 

//-----------------------------------------------------------------//
//-----------------------------------------------------------------//
//-----------------------------------------------------------------//


  $err='';
  session_start();
  $imagenCadena = $_SESSION["imagencadena"]; 
  $pot = trim(strtolower($imagenCadena));
  $server_name = getenv ("SERVER_NAME");       // Server Name
  $request_uri = getenv ("REQUEST_URI");       // Requested UR
  $miarr = '';

// check antispam and lang
if (isset($_POST['contact-submit'])) {

    //call lang: array i18n
    $LANG = $_POST['contact']['q_lang']; 
    if (is_file('lang/'.$LANG.'.php')){
 	 include ('lang/'.$LANG.'.php');
    } else {
 	 include ('lang/en_US.php');
    }


    //antispam
    $MIURL = $_POST['contact']['q_uri'];
    $posmiar= strpos($MIURL, 'miarr=');
    if ($posmiar){
        $MIURL = substr($MIURL,0, $posmiar - 1);	 
        $_POST['contact']['q_uri'] = $MIURL;
    }
    if ($_POST['contact']['leaveso'] != 'leaveso' or $_POST['contact']['leaveblank']!=''){
       echo '<html>';
       echo '<head>';
       echo '</head>';
       echo '<body>';
       echo '<div style="padding: 20px; border: 4px double; margin: 20%;">';
       echo $i18n['spam'].'<br />';
       echo '<a href="http://'.$server_name.$MIURL.'">'.$i18n['back'].'</a>';
       echo '</div>';
       echo '</body>';
       echo '</html>';   
       exit; 
    }  
}

//------------------------
//START CONTACT
//------------------------
 if (@$_GET['tp'] == 'contact') { 

	if (isset($_POST['contact-submit'])) {
	         $log_file= $_POST['contact']['q_file'];
                 $EMAIL = $_POST['contact']['q_email'];
		 $sendphpmail = $_POST['contact']['q_send'];
                 $qcaptcha =  $_POST['contact']['q_captcha'];
                 $sitename =  stripslashes($_POST['contact']['q_sitename']);
                 $usus = '';      
                 if (array_key_exists('q_usus',$_POST['contact'])){
                     $usus = $_POST['contact']['q_usus'];
                     for ($q = 4; $q <= $usus; $q++){
                           if (isset($_POST['contact']['usu'.$q])){  
                               $usu[$q] = $_POST['contact']['usu'.$q];
                           } 
                     }  
                 }    


                 //check captcha
                 $captcha = $_POST['contact']['pot'];
                   
                 if ($qcaptcha == "true") {
	             if ( $pot == trim(strtolower($_POST['contact']['pot']))) {
                          $err = '';
        	     }
	             else {
 		 	  $err = $i18n['MSG_CAPTCHA_FAILED'];
		     }
                 }

                 //check name
		 if ( $_POST['contact'][$i18n['Nb']] != '' ) {
                      if ($_POST['contact'][$i18n['Nb']] == $i18n['Nb']){
                        $_POST['contact'][$i18n['Nb']] = '';
		      }
                 }

                 //check email
		 if ( $_POST['contact'][$i18n['Em']] != '' ) {
                      if ($_POST['contact'][$i18n['Em']] != $i18n['Em']){
			$from =  $_POST['contact'][$i18n['Em']];
                      } else {
                        $_POST['contact'][$i18n['Em']]='';
		      }
                 }
       
                 //check subject
                 $subject2 = ''; 
		 if ( $_POST['contact'][$i18n['Sub']] != '' ) {
                      if ($_POST['contact'][$i18n['Sub']] != $i18n['Sub']){
			    $subject = $_POST['contact'][$i18n['Sub']];
		      } else { 
			    $subject = $i18n['CONTACT_FORM_SUB'].' '.$i18n['WHO'].' '.$sitename;
                            $_POST['contact'][$i18n['Sub']] = $i18n['CONTACT_FORM_SUB'].' '.$i18n['WHO'].' '.$sitename;
			    $subject2 =  $i18n['Sub'];
                      }
		 } 

                 //check message
		if ( $_POST['contact'][$i18n['Ms']] != '' ) {
                      if ($_POST['contact'][$i18n['Ms']] == $i18n['Ms']){
			   $_POST['contact'][$i18n['Ms']] = '';
		      }
		} 


		$temp = $_POST['contact'];
                $temp[$i18n['Ms']] = $_POST['contact'][$i18n['Ms']];


                //release variables
		unset($temp['pot']);
		unset($temp['contact-submit']);
		unset($temp['submit']);
                unset($temp['leaveso']);
                unset($temp['leaveblank']);

		if ($err == '' && trim($_POST['contact'][$i18n['Em']]) !='' && trim($_POST['contact'][$i18n['Ms']]) !='') {

			$headers = "From: ".$from."\r\n";
			$headers .= "Return-Path: ".$from."\r\n";
			$headers .= "Content-type: text/html; charset=UTF-8 \r\n";

			$body = '"'.$subject.'": <a href="http://'.$server_name.$MIURL.'">http://'.$server_name.$MIURL.'</a>';
			$body .= "<hr><br />";


			if ( ! file_exists($log_file) ) {
               			 $xml = new SimpleXMLExtended('<channel></channel>');
			} else
			{
				$xmldata = file_get_contents($log_file);
		                $xml = new SimpleXMLExtended($xmldata);
			}

			$thislog = $xml->addChild('entry');
			$thislog->addChild('date', date('r'));
			$cdata = $thislog->addChild('captcha');
			$cdata->addCData($captcha);
			$cdata = $thislog->addChild('ip_address');
			$ip = getenv("REMOTE_ADDR"); 
			$cdata->addCData(htmlentities($ip, ENT_QUOTES, 'UTF-8'));
                        $body .= "Ip: ". $ip ."<br />"; 
			foreach ( $temp as $key => $value ) {
			    if (substr($key, 0, 2) != 'q_') {
				$body .= ucfirst($key) .": ". $value ."<br />";
				$cdata = $thislog->addChild(clean_url($key));
				$cdata->addCData(htmlentities($value, ENT_QUOTES, 'UTF-8'));
			    }
			}
			XMLsave($xml, $log_file);
                        $seg = 2;  
                        if ($sendphpmail == false or $sendphpmail == 'false') {
			    $result = mail($EMAIL,$subject,$body,$headers);
                            if ($usus != ''){
                                  foreach ($usu as $key=>$value){
                                         $result =  mail($value,$subject,$body,$headers);
                                         $result1[$key] =  $result;
                                  }
                            }
                        } else if ($sendphpmail == true or $sendphpmail== 'true') {
                            if (is_dir('../PHPMailer_v5.1') and file_exists('../PHPMailer_v5.1/class.phpmailer.php')){
				
				require('../PHPMailer_v5.1/class.phpmailer.php');   
  				$message = new PHPMailer(true); // the true param means it will throw exceptions on errors, which we need to catch
                                $message->CharSet = "utf-8"; 
                                $message->SMTPDebug = false;    // enables SMTP debug information (for testing)
                                                                   // false = disabled debug
                                                                   // 1 = errors and messages
                                                                   // 2 = messages only

        			$message->IsSMTP();            // telling the class to use SMTP
                                $message->SMTPAuth = true;     // enable SMTP authentication

                        /*        //GMAIL Configuration
        	     	  	$message->SMTPSecure = "ssl";                 // sets the prefix to the servier
        			$message->Host       = "smtp.gmail.com";      // sets GMAIL as the SMTP se
        			$message->Port       = 465;                   // set the SMTP port for the GMAIL server
        			$message->Username   = "youuser@gmail.com";   // GMAIL user account: youuser@gmail.com
        			$message->Password   = "youpass";         // GMAIL passwordrver 
                                $message->From   = "youuser@gmail.com";       // you GMAIL email 
                      */          //end GMAIL Configuration

                                //ONO configuration     
                       /*       $message->SMTPSecure = "";                  // sets the prefix to the servier
        			$message->Host       = "smtp.ono.com";       // sets ONO as the SMTP server
        			$message->Port       = 25;                   // set the SMTP port for the ONO server
        			$message->Username   = "username";               // ONO username 
        			$message->Password   = "pass";            // ONO password
                                $message->From   = "user@ono.com";           // you ono email 
                       */       //end ONO Configuration

                                //HOTMAIL configuration     
        			$message->SMTPSecure = "tls";                   // sets the prefix to the servier
        			$message->Host       = "smtp.live.com";         // sets hotmail as the SMTP server
        			$message->Port       = 587;                     // set the SMTP port for hotmail server
        			$message->Username   = "youruser@hotmail.com";  // hotmail user account
        			$message->Password   = "yourpass";               // hotmail password
                                $message->From   = "youruser@hotmail.com";      // you hotmail email 
                              //end HOTMAIL Configuration


        			$message->AddAddress($EMAIL, '');  //Recipient's address set 
        			$message->Subject = $subject;
                                $message->FromName   = $from;
        			$message->MsgHTML("$body");
			        $result=$message->Send();
                           } else {
                                echo strtoupper($i18n['errphphmail']).'<br />';
                           }
			}

			//results	
			if ($result=='1') {
				$msgshw = $i18n['MSG_CONTACTSUC'].'<br /><br />';
			} else {
                                $seg = 10;  
				$msgshw = '<p>'.$i18n['MSG_guestERR'].'</p><br />';
                                $msgshw .= "Mailer Error: " . $mail->ErrorInfo;
			}
		} else { //finaliza if err=''
                            //release variables
                            unset ($temp['q_email']);
                            unset ($temp['q_file']);
                            unset ($temp['q_uri']);
                            unset ($temp['q_send']);
                            unset ($temp['q_captcha']);
                            if ($subject2 != '') {
                                    $temp[$i18n['Sub']] = $subject2;
                            }

                            $miarr = '';
                            $miarr = serialize($temp);
                            $miarr = urlencode($miarr);
                            if (strpos($MIURL, '?')){
                                $miarr = '&amp;miarr='.$miarr;
                            } else {
                                $miarr = '?miarr='.$miarr;
                            }    
                            //if there are some error in captcha ó empty fields.
                             $seg = 6;
		     if (trim($err) !=''){
			$msgshw = '<p>'.$err.'.<br />Captcha code: '.$pot.'<br / >Code wrote: '.$_POST['contact']['pot'].'</p><br /><br />';
		     }
	             else {
			$msgshw = '*** '.strtoupper($i18n['Co']).' ***<br /><br />';
		     }
		}

	}
  }

  echo '<html>';
  echo '<head>';
  echo '<meta http-equiv="Refresh" content="'.$seg.';url=http://'.$server_name.$MIURL.$miarr.'">';
  echo '</head>';
  echo '<body>';
  echo '<div style="padding: 20px; border: 4px double; margin: 20%;">';
  echo $msgshw;
  echo $i18n['redir'].$seg.$i18n['redir1'].$i18n['back'].'.<br />';
  echo '<a href="http://'.$server_name.$MIURL.$miarr.'">'.$i18n['back'].'</a>';
  echo '</div>';
  echo '</body>';
  echo '</html>';
?>
